<template>
  <modal
    name="store-invoice"
    height="auto"
    :shift-y="0.2"
    :click-to-close="false"
    :scrollable="true"
    @before-open="beforeOpen"
    @before-close="beforeClose"
  >
    <div class="modal-header">
      <h5 class="modal-title">
        Invoice
      </h5>

      <div
        class="close"
        @click="$modal.hide('store-invoice')"
      >
        <span aria-hidden="true">&times;</span>
      </div>
    </div>

    <div class="modal-body">
      <div class="row">
        <div class="col-12">
          <ul
            id="myTab"
            class="nav nav-tabs"
            role="tablist"
          >
            <li
              class="nav-item"
              role="presentation"
            >
              <a
                id="home-tab"
                class="nav-link active"
                data-toggle="tab"
                href="#home"
                role="tab"
                aria-controls="home"
                aria-selected="true"
              >Data</a>
            </li>
            <li
              class="nav-item"
              role="presentation"
            >
              <a
                id="products-tab"
                class="nav-link"
                data-toggle="tab"
                href="#products"
                role="tab"
                aria-controls="products"
                aria-selected="false"
              >Products</a>
            </li>
            <li
              class="nav-item"
              role="presentation"
            >
              <a
                id="settings-tab"
                class="nav-link"
                data-toggle="tab"
                href="#settings"
                role="tab"
                aria-controls="settings"
                aria-selected="false"
              >Settings</a>
            </li>
          </ul>
          <div
            id="myTabContent"
            class="tab-content"
          >
            <div
              id="home"
              class="tab-pane fade show active"
              role="tabpanel"
              aria-labelledby="home-tab"
            >
              <div class="form-group mt-3">
                <label>Number</label>
                <input
                  v-model="invoice.number"
                  type="text"
                  class="form-control"
                >
              </div>

              <div class="form-group mt-2">
                <label>Date</label>
                <input
                  v-model="invoice.date"
                  type="date"
                  class="form-control"
                >
              </div>

              <div class="form-group mt-2">
                <label>Bank</label>
                <div class="row m-0">
                  <div style="flex: 1; margin-right: 10px">
                    <v-select
                      v-model="invoice.bank"
                      :options="banks"
                      label="name"
                      @search:focus="searchBanks"
                      @input="addBank"
                    />
                  </div>

                  <button
                    class="btn btn-outline-success"
                    @click="
                      $modal.show('store-bank', {
                        view: 'create',
                      })
                    "
                  >
                    New Bank
                  </button>
                </div>
              </div>

              <div class="form-group mt-2">
                <label>Customer</label>
                <div class="row m-0">
                  <div style="flex: 1; margin-right: 10px">
                    <v-select
                      v-model="invoice.customer"
                      :options="customers"
                      label="name"
                      @search:focus="searchCustomers"
                      @input="addCustomers"
                    />
                  </div>

                  <button
                    class="btn btn-outline-success"
                    @click="
                      $modal.show('store-customer', {
                        view: 'create',
                      })
                    "
                  >
                    New Customer
                  </button>
                </div>
              </div>
            </div>
            <div
              id="products"
              class="tab-pane fade"
              role="tabpanel"
              aria-labelledby="products-tab"
            >
              <div class="form-group mt-2">
                <label>Products</label>
                <div class="row m-0">
                  <div style="flex: 1; margin-right: 10px">
                    <v-select
                      v-model="newPackage.name"
                      :options="packages"
                      label="name"
                      style="height: 37px"
                      @search:focus="searchPackages"
                      @input="addPackages"
                    />
                  </div>
                  <button
                    class="btn btn-outline-success"
                    @click="
                      $modal.show('store-package', {
                        view: 'create',
                      })
                    "
                  >
                    New Product
                  </button>
                </div>
              </div>

              <div class="row">
                <div class="col-5">
                  <div class="form-group mt-2">
                    <label>Quantity</label>
                    <input
                      v-model="newPackage.pivot.quantity"
                      type="number"
                      class="form-control"
                    >
                  </div>
                </div>
                <div class="col-5">
                  <div class="form-group mt-2">
                    <label>Discount</label>
                    <div class="input-group">
                      <input
                        v-model="newPackage.pivot.discount"
                        type="number"
                        class="form-control"
                      >
                      <div class="input-group-append">
                        <span class="input-group-text">%</span>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="col-2 d-flex align-items-end justify-content-end">
                  <div class="form-group mt-2">
                    <button
                      class="btn btn-primary"
                      :disabled="!newPackage.name || !newPackage.pivot.quantity"
                      @click="savePackage()"
                    >
                      Add
                    </button>
                  </div>
                </div>
              </div>
              <table
                v-if="invoice.packages.length"
                class="table mt-4"
              >
                <thead>
                  <tr>
                    <th>Product</th>
                    <th>Quantity</th>
                    <th>Discount</th>
                    <th>Action</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="product in invoice.packages">
                    <td>{{ product.name }}</td>
                    <td>{{ product.pivot.quantity }}</td>
                    <td>
                      <span
                        v-if="product.pivot.discount"
                      >{{ product.pivot.discount }} %</span>
                      <span v-else>0%</span>
                    </td>
                    <td>
                      <button
                        class="btn btn-sm btn-danger"
                        @click="removePackage(product)"
                      >
                        <i class="fas fa-trash" />
                      </button>
                    </td>
                  </tr>
                </tbody>
              </table>
            </div>
            <div
              id="settings"
              class="tab-pane fade"
              role="tabpanel"
              aria-labelledby="settings-tab"
            >
              <div class="form-group mt-2">
                <label>Note</label>
                <textarea
                  id=""
                  v-model="notes[0].description"
                  name=""
                  class="form-control"
                  cols="30"
                  rows="10"
                />
              </div>
              <div class="form-check">
                <input
                  id="defaultCheck1"
                  v-model="notes[0].flag"
                  class="form-check-input"
                  type="checkbox"
                >
                <label
                  class="form-check-label"
                  for="defaultCheck1"
                >
                  Display
                </label>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="modal-footer">
      <button
        class="btn btn-outline-danger"
        type="button"
        @click="remove()"
      >
        Delete Invoice
      </button>
      <button
        type="button"
        class="btn btn-primary"
        @click="$modal.show('invoice-preview', { invoice: invoice })"
      >
        <i class="far fa-file-pdf mr-2" /> Preview
      </button>

      <button
        v-if="view == 'create'"
        type="button"
        class="btn btn-success"
        :disabled="
          !invoice.number ||
            !invoice.date ||
            !invoice.bank ||
            !invoice.customer ||
            !invoice.packages.length
        "
        @click="create()"
      >
        <i class="fas fa-save pr-2" /> Create
      </button>

      <button
        v-if="view == 'edit'"
        type="button"
        class="btn btn-success"
        :disabled="
          !invoice.number ||
            !invoice.date ||
            !invoice.bank ||
            !invoice.customer ||
            !invoice.packages.length
        "
        @click="update()"
      >
        <i class="fas fa-save pr-2" /> Update
      </button>
    </div>

    <store-bank
      :banks="banks"
      @bank-create="bankCreate"
    />

    <store-customer
      :customers="customers"
      @customer-create="customerCreate"
    />

    <store-package
      :packages="packages"
      @package-create="packageCreate"
    />
  </modal>
</template>

<script>
export default {
  props: ["invoices"],

  data() {
    return {
      invoice: {
        number: null,

        date: null,

        bank: null,

        bank_id: null,

        customer: null,

        customer_id: null,

        packages: [],

        notes: [],
      },

      newPackage: {
        id: null,

        name: null,

        price: null,

        pivot: {
          discount: null,

          quantity: null,
        },
      },

      customers: [],

      banks: [],

      packages: [],

      notes: [
        {
          description: "",
          flag: false
        }
      ],
      view: "create",
    };
  },

  methods: {
    beforeClose(event) {
      this.invoice = {
        number: "",

        date: "",

        bank: "",

        bank_id: "",

        customer: "",

        customer_id: "",

        packages: [],

        notes: []
      };
    },

    beforeOpen(event) {
      event.params.invoice
        ? (this.invoice = JSON.parse(JSON.stringify(event.params.invoice)))
        : [];

      event.params.view ? (this.view = event.params.view) : [];

      if(this.invoice.notes.length) this.notes = this.invoice.notes
    },

    bankCreate(event) {
      this.invoice.bank = event.bank;

      this.invoice.bank_id = event.bank.id;
    },

    customerCreate(event) {
      this.invoice.customer = event.customer;

      this.invoice.customer_id = event.customer.id;
    },

    packageCreate(event) {
      this.newPackage = {
        id: event.package.id,

        name: event.package.name,

        price: event.package.price,

        pivot: {
          discount: event.package.discount,

          quantity: "",
        },
      };
    },

    searchCustomers() {
      axios
        .post("/api/customers/list", {
          getAll: true,

          orderBy: {
            name: "id",

            value: "desc",
          },
        })
        .then((response) => {
          this.customers = response.data;
        });
    },

    searchBanks() {
      axios
        .post("/api/banks/list", {
          getAll: true,

          orderBy: {
            name: "id",

            value: "desc",
          },
        })
        .then((response) => {
          this.banks = response.data;
        });
    },

    searchPackages() {
      axios
        .post("/api/packages/list", {
          getAll: true,

          orderBy: {
            name: "id",

            value: "desc",
          },
        })
        .then((response) => {
          this.packages = response.data;
        });
    },

    addCustomers(value) {
      if (value) {
        this.invoice.customer = value;

        this.invoice.customer_id = value.id;
      }
    },

    addBank(value) {
      if (value) {
        this.invoice.bank = value;

        this.invoice.bank_id = value.id;
      }
    },

    addPackages(value) {
      if (value) {
        this.newPackage = {
          id: value.id,

          name: value.name,

          price: value.price,

          pivot: {
            discount: value.discount,

            quantity: "",
          },
        };
      }
    },

    savePackage() {
      this.invoice.packages.push(this.newPackage);

      this.newPackage = {
        id: "",

        name: "",

        price: "",

        discount: "",

        pivot: {
          quantity: "",
        },
      };
    },

    removePackage(product) {
      if (product.pivot.quantity > 1) {
        product.pivot.quantity = product.pivot.quantity - 1;
      } else {
        this.invoice.packages.splice(product, 1);
      }
    },

    create() {
      
      this.invoice.notes = this.notes

      axios.post("/api/invoices/store", this.invoice).then((response) => {
        // Close modal
        this.$modal.hide("store-invoice");

        // Add invoice in list
        this.invoices.unshift(response.data);

        // Show notification
        this.$toasted.show(
          "<i class='fas fa-check mr-2'></i> Invoice Succesfully Created"
        );
      });
    },

    update() {
      axios
        .put("/api/invoices/" + this.invoice.id, this.invoice)
        .then((response) => {

          this.$emit("update", response.data)

          // Close modal
          this.$modal.hide("store-invoice");

          // Show notification
          this.$toasted.show(
            "<i class='fas fa-check mr-2'></i> Invoice Succesfully Updated"
          );
        });
    },

    remove() {
      Vue.toasted.clear();

      this.$toasted.show(
        "<i class='fas fa-trash-alt mr-2'> </i> Delete Invoice ?",
        {
          type: "error",

          duration: null,

          action: [
            {
              text: "Yes",

              onClick: (e, toastObject) => {
                toastObject.goAway(0);

                axios
                  .post("/api/invoices/delete/" + this.invoice.id)
                  .then((response) => {
                    this.invoices.splice(this.invoice, 1);

                    // Close modal
                    this.$modal.hide("store-invoice");

                    this.$toasted.show(
                      "<i class='fas fa-check mr-2'></i> Invoice Successfully Deleted !"
                    );
                  });
              },
            },
            {
              text: "Cancel",

              onClick: (e, toastObject) => {
                toastObject.goAway(0);
              },
            },
          ],
        }
      );
    },
  },
};
</script>

<style>
/*.vs__dropdown-toggle {
	height: 37px;
}*/

.vs__dropdown-toggle {
  padding: 5px !important;
  background-color: white;
}

.vm--modal {
  overflow: initial !important;
}

.vs__actions {
  padding-top: 0px !important;
}
</style>
